unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button4: TButton;
    Label4: TLabel;
    Edit1: TEdit;
    Label5: TLabel;
    Button5: TButton;
    Label6: TLabel;
    function lies_n:integer; //Von Hand eingetippt
    procedure VerschlMemo(const m1:Tmemo; var m2:Tmemo; n:integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const
  Basis=224; //Ziffern 0,1,2,...,223 ASCII ohne Steuerzeichen
var
  Form1: TForm1;

implementation

{$R *.DFM}

function f(const i,n:integer):integer; //Bijektiv von {0,1,...,Basis}
  //Statt des Csarcodes knnt hier jede beliebige bijektive Funktion stehen
  //Die Umkehrfunktion zum Entschlsseln msste dann explizit angegeben werden
begin
  result:=i+n;
  if result>=Basis then result:=result-Basis; //Falls n>0: Basis->0 Basis+1->1 ...
  if result<0 then result:=result+Basis;  //Falls n<0: ... -2->Basis-2 -1->Basis-1
end;

procedure VerschlEinBuchstabe(var c:char; n:integer); //Csar-Code
  //Verschiebung im ASCII-Bereich 32 bis 255
  //(ASCII-Bereich unter 32 sind Steuerzeichen)
  var i:integer;
begin
  i:=f(ord(c)-32,n);
  c:=char(i+32);
end;

Procedure VerschlZeile(var s:string; n:integer);
  var k:integer;
begin
  for k:=1 to length(s) do VerschlEinBuchstabe(s[k],n);
end;

function TForm1.lies_n:integer; //Von Hand eingetippt
begin
 try
    result:=StrtoInt(edit1.text);
  Except
    showmessage('Bitte geben sie fr n eine Zahl ein');
    result:=0;
    exit;
  End;
  result:=result mod Basis;
  edit1.text:=intToStr(result);
end;



Procedure Tform1.VerschlMemo(const m1:Tmemo; var m2:Tmemo; n:integer);
  //const vor m1 spart Speicherplatz (lohnt sich hier):
  //Es wird keine neue Instanz erzeugt
  var i:integer;
      s:string;
begin
  m2.lines.clear;
  for i:=0 to m1.lines.count-1 do Begin
    s:=m1.lines[i];
    verschlZeile(s,n);
    m2.lines.add(s);
  End;
end;

procedure TForm1.Button1Click(Sender: TObject);
  var n: integer;
begin
  n:=lies_n;
  VerschlMemo(memo1,memo2,n);
  memo3.Lines.Clear;
end;

procedure TForm1.Button2Click(Sender: TObject);
 var n: integer;
begin
  n:=lies_n;
  VerschlMemo(memo2,memo3,-n);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 close
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

 memo1.Text:='Unberhmte letzte Worte:'#13#10+
             '-------------------------'#13#10+
             'Fahr ruhig weiter!'#13#10+
             'Von rechts kommt niemand.'#13#10+
             'Jedenfalls ist bisher nie jemand gekommen.';

label6.caption:='0<n<'+IntToStr(Basis);

end;

end.
